﻿--{{{ Libraries

local RL = AceLibrary("Roster-2.1")
local Aura = AceLibrary("SpecialEvents-Aura-2.0")
local L = AceLibrary("AceLocale-2.2"):new("GridStatusHots")

--}}}
--

local hottimer = { }
local playerClass, englishClass = UnitClass("player")

--{{{ Localization

L:RegisterTranslations("enUS", function()
	return {
		["My HoTs"] = true,
		["Renew"] = true,
		["Rejuvenation"] = true,
		["Regrowth"] = true,
		["Lifebloom"] = true,
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
		["Buff: My Lifebloom"] = true,
		["Threshold to activate color 2"] = true,
		["Threshold to activate color 3"] = true,
		["Color 2"] = true,
		["Color 3"] = true,
	}
end)

L:RegisterTranslations("deDE", function()
	return {
		["My HoTs"] = "Meine HoTs",
		["Renew"] = "Erneuerung",
		["Rejuvenation"] = "Verjüngung",
		["Regrowth"] = "Nachwachsen",
		["Lifebloom"] = "Blühendes Leben",
		["Buff: Hot Count"] = "Buff: Anzahl HoTs",
		["Buff: My Renew"] = "Buff: Meine Erneuerung",
		["Buff: My Rejuvenation"] = "Buff: Meine Verjüngung",
		["Buff: My Regrowth"] = "Buff: Mein Nachwachsen",
		["Buff: My Lifebloom"] = "Buff: Mein Blühendes Leben",
		["Threshold to activate color 2"] = "Schwelle zum Aktivieren von Farbe 2",
		["Threshold to activate color 3"] = "Schwelle zum Aktivieren von Farbe 3",
		["Color 2"] = "Farbe 2",
		["Color 3"] = "Farbe 3",
}
end)

L:RegisterTranslations("koKR", function()
	return {
		["My HoTs"] = "자신의 지속 치유",
		["Renew"] = "소생",
		["Rejuvenation"] = "회복",
		["Regrowth"] = "재생",
		["Lifebloom"] = "피어나는 생명",
		["Buff: Hot Count"] = "버프: 지속 치유 갯수",
		["Buff: My Renew"] = "버프 : 자신의 소생",
		["Buff: My Rejuvenation"] = "버프 : 자신의 회복",
		["Buff: My Regrowth"] = "버프 : 자신의 재생",
		["Buff: My Lifebloom"] = "버프: 자신의 피어나는 생명",
		["Threshold to activate color 2"] = "색상 2을 사용할 수치",
		["Threshold to activate color 3"] = "색상 3을 사용할 수치",
		["Color 2"] = "색상 2",
		["Color 3"] = "색상 3",
	}
end)

L:RegisterTranslations("esES", function()
	return {
		["My HoTs"] = "My HoTs", --need translation
		["Renew"] = "Renovar",
		["Rejuvenation"] = "Rejuvenecimiento",
		["Regrowth"] = "Recrecimiento",
		["Lifebloom"] = "Flor de vida",
		["Buff: HoT Count"] = "Buff: HoT Count", --need translation
		["Buff: My Renew"] = "Buff: My Renovar", --need check
		["Buff: My Rejuvenation"] = "Buff: My Rejuvenecimiento", --need check
		["Buff: My Regrowth"] = "Buff: My Recrecimiento", --need check
		["Buff: My Lifebloom"] = "Buff: My Flor de vida", --need check
		["Threshold to activate color 2"] = "Threshold to activate color 2", --need translation
		["Threshold to activate color 3"] = "Threshold to activate color 3", --need translation
		["Color 2"] = "Color 2", --need translation
		["Color 3"] = "Color 3", --need translation
	}
end)

L:RegisterTranslations("frFR", function()
	return {
		["My HoTs"] = "My HoTs", --need translation
		["Renew"] = "Rénovation",
		["Rejuvenation"] = "Récupération",
		["Regrowth"] = "Rétablissement",
		["Lifebloom"] = "Fleur de vie",
		["Buff: Hot Count"] = "Buff: HoT Count", --need translation
		["Buff: My Renew"] = "Buff: My Rénovation", --need check
		["Buff: My Rejuvenation"] = "Buff: My Récupération", --need check
		["Buff: My Regrowth"] = "Buff: My Rétablissement", --need check
		["Buff: My Lifebloom"] = "Buff: My Fleur de vie", --need check
		["Threshold to activate color 2"] = "Threshold to activate color 2", --need translation
		["Threshold to activate color 3"] = "Threshold to activate color 3", --need translation
		["Color 2"] = "Color 2", --need translation
		["Color 3"] = "Color 3", --need translation
	}
end)

L:RegisterTranslations("zhCN", function()
	return {
		["My HoTs"] = "我的HoTs",
		["Renew"] = "恢复",
		["Rejuvenation"] = "回春术",
		["Regrowth"] = "癒合",
		["Lifebloom"] = "生命绽放",
		["Buff: Hot Count"] = "Buff: Hot统计",
		["Buff: My Renew"] = "Buff: 我的恢复",
		["Buff: My Rejuvenation"] = "Buff: 我的回春",
		["Buff: My Regrowth"] = "Buff: 我的愈合",
		["Buff: My Lifebloom"] = "Buff: 我的生命绽放",
		["Threshold to activate color 2"] = "Threshold to activate color 2", --need translation
		["Threshold to activate color 3"] = "Threshold to activate color 3", --need translation
		["Color 2"] = "Color 2", --need translation
		["Color 3"] = "Color 3", --need translation
	}
end)

L:RegisterTranslations("zhTW", function()
	return {
		["My HoTs"] = "我的HoT",
		["Renew"] = "恢復",
		["Rejuvenation"] = "回春術",
		["Regrowth"] = "癒合",
		["Lifebloom"] = "生命之花",
		["Buff: Hot Count"] = "Buff: Hot數",
		["Buff: My Renew"] = "Buff: 我的恢復",
		["Buff: My Rejuvenation"] = "Buff: 我的回春術",
		["Buff: My Regrowth"] = "Buff: 我的癒合",
		["Buff: My Lifebloom"] = "Buff: 我的生命之花",
		["Threshold to activate color 2"] = "Threshold to activate color 2", --need translation
		["Threshold to activate color 3"] = "Threshold to activate color 3", --need translation
		["Color 2"] = "Color 2", --need translation
		["Color 3"] = "Color 3", --need translation
	}
end)

--}}}

GridStatusHots = GridStatus:NewModule("GridStatusHots")
GridStatusHots.menuName = L["My HoTs"]

--{{{ AceDB defaults
--
GridStatusHots.defaultDB = {
	alert_renew = {
		text = L["Buff: My Renew"],
		desc = L["Buff: My Renew"],
		enable = true,
		priority = 99,
		range = false,
		threshold2 = 4,
		threshold3 = 2,
		color = { r = 0, g = 1, b = 0, a = 1 },
		color2 = { r = 1, g = 1, b = 0, a = 1 },
		color3 = { r = 1, g = 0, b = 0, a = 1 },
	},
	alert_rejuv = {
		text = L["Buff: My Rejuvenation"],
		desc = L["Buff: My Rejuvenation"],
		enable = true,
		priority = 99,
		range = false,
		threshold2 = 4,
		threshold3 = 2,
		color = { r = 0, g = 0, b = 1, a = 1 },
		color2 = { r = 1, g = 1, b = 0, a = 1 },
		color3 = { r = 1, g = 0, b = 0, a = 1 },
	},
	alert_regrow = {
		text = L["Buff: My Regrowth"],
		desc = L["Buff: My Regrowth"],
		enable = true,
		priority = 98,
		range = false,
		threshold2 = 4,
		threshold3 = 2,
		color = { r = 1, g = 1, b = 1, a = 1 },
		color2 = { r = 1, g = 1, b = 0, a = 1 },
		color3 = { r = 1, g = 0, b = 0, a = 1 },
	},
	alert_lifebl = {
		text = L["Buff: My Lifebloom"],
		desc = L["Buff: My Lifebloom"],
		enable = true,
		priority = 99,
		range = false,
		threshold2 = 4,
		threshold3 = 2,
		color = { r = 1, g = 0, b = 1, a = 1 },
		color2 = { r = 1, g = 1, b = 0, a = 1 },
		color3 = { r = 1, g = 0, b = 0, a = 1 },
	},
	alert_tothots = {
		text = L["Buff: Hot Count"],
		desc = L["Buff: Hot Count"],
		enable = true,
		priority = 97,
		range = false,
		color = { r = 0, g = 1, b = 0, a = 1 },
	},
}


local renew_hotcolors = {
	["threshold2"] = {
		type = "range",
		name = L["Threshold to activate color 2"],
		desc = L["Threshold to activate color 2"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_renew.threshold2
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_renew.threshold2 = v
		end,
	},
	["color2"] = {
		type = "color",
		name = L["Color 2"],
		desc = L["Color 2"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_renew.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_renew.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["threshold3"] = {
		type = "range",
		name = L["Threshold to activate color 3"],
		desc = L["Threshold to activate color 3"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_renew.threshold3
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_renew.threshold3 = v
		end,
	},
	["color3"] = {
		type = "color",
		name = L["Color 3"],
		desc = L["Color 3"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_renew.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_renew.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}

local rejuv_hotcolors = {
	["threshold2"] = {
		type = "range",
		name = L["Threshold to activate color 2"],
		desc = L["Threshold to activate color 2"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_rejuv.threshold2
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_rejuv.threshold2 = v
		end,
	},
	["color2"] = {
		type = "color",
		name = L["Color 2"],
		desc = L["Color 2"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_rejuv.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_rejuv.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["threshold3"] = {
		type = "range",
		name = L["Threshold to activate color 3"],
		desc = L["Threshold to activate color 3"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_rejuv.threshold3
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_rejuv.threshold3 = v
		end,
	},
	["color3"] = {
		type = "color",
		name = L["Color 3"],
		desc = L["Color 3"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_rejuv.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_rejuv.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}

local regrow_hotcolors = {
	["threshold2"] = {
		type = "range",
		name = L["Threshold to activate color 2"],
		desc = L["Threshold to activate color 2"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_regrow.threshold2
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_regrow.threshold2 = v
		end,
	},
	["color2"] = {
		type = "color",
		name = L["Color 2"],
		desc = L["Color 2"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_regrow.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_regrow.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["threshold3"] = {
		type = "range",
		name = L["Threshold to activate color 3"],
		desc = L["Threshold to activate color 3"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_regrow.threshold3
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_regrow.threshold3 = v
		end,
	},
	["color3"] = {
		type = "color",
		name = L["Color 3"],
		desc = L["Color 3"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_regrow.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_regrow.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}

local lifebl_hotcolors = {
	["threshold2"] = {
		type = "range",
		name = L["Threshold to activate color 2"],
		desc = L["Threshold to activate color 2"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_lifebl.threshold2
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_lifebl.threshold2 = v
		end,
	},
	["color2"] = {
		type = "color",
		name = L["Color 2"],
		desc = L["Color 2"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_lifebl.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_lifebl.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["threshold3"] = {
		type = "range",
		name = L["Threshold to activate color 3"],
		desc = L["Threshold to activate color 3"],
		max = 10,
		min = 1,
		step = .5,
		get = function ()
			      return GridStatusHots.db.profile.alert_lifebl.threshold3
		      end,
		set = function (v)
			       GridStatusHots.db.profile.alert_lifebl.threshold3 = v
		end,
	},
	["color3"] = {
		type = "color",
		name = L["Color 3"],
		desc = L["Color 3"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusHots.db.profile.alert_lifebl.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusHots.db.profile.alert_lifebl.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}


--}}}


function GridStatusHots:OnInitialize()
	self.super.OnInitialize(self)

	self:RegisterStatus("alert_tothots", L["Buff: Hot Count"], alert_tothots)
	if englishClass == "PRIEST" then
		self:RegisterStatus("alert_renew", L["Buff: My Renew"], renew_hotcolors)
	end
	if englishClass == "DRUID" then
		self:RegisterStatus("alert_rejuv", L["Buff: My Rejuvenation"], rejuv_hotcolors)
		self:RegisterStatus("alert_regrow", L["Buff: My Regrowth"], regrow_hotcolors)
		self:RegisterStatus("alert_lifebl", L["Buff: My Lifebloom"], lifebl_hotcolors)
	end
end

function GridStatusHots:OnEnable()
	local f = function()
		GridStatusHots:UpdateAll()
	end
	self:ScheduleRepeatingEvent("GHS_Refresh", f,.5)
end

function GridStatusHots:Reset()
	self.super.Reset(self)
end

function GridStatusHots:UpdateAll()
	for u in RL:IterateRoster() do
		local name = UnitName(u.unitid) or ""
		local recnt,rgcnt,rjcnt,lbcnt = 0,0,0,0
		local retime,rjtime,rgtime,lbtime,hcnttxt = nil,nil,nil,nil,nil
		-- Find number of hots pr unit
		for i=1,40 do -- this is not raid numbers, its possible buffs/debuffs to scan per member,
			local bname,brank,btexture,bcount,bdur, btime = UnitBuff(u.unitid, i)
			if not bname then break end
			if bname and bname == L["Renew"] then
				recnt = recnt + 1
				if btime then retime = btime+1 end
			end
			if bname and bname == L["Regrowth"] then
				rgcnt = rgcnt + 1
				if btime then rgtime = btime+1 end
			end
			if bname and bname == L["Rejuvenation"] then
				rjcnt = rjcnt + 1
				if btime then rjtime = btime+1 end
			end
			if bname and bname == L["Lifebloom"] then
				lbcnt = lbcnt + 1
				if btime then lbtime = btime+1 end
			end
		end
		-- Set number of hots currently running on all units
		if recnt > 0 or rjcnt > 0 or rgcnt > 0 or lbcnt > 0 then
			hcnttxt = tostring(recnt+rjcnt+rgcnt+lbcnt)
			local settings = self.db.profile.alert_tothots
			self.core:SendStatusGained(name, "alert_tothots",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(hcnttxt)
			)
		else
			if self.core:GetCachedStatus(name, "alert_tothots") then self.core:SendStatusLost(name, "alert_tothots") end
		end

		if retime then
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_renew
			local hotcolor = settings.color
			if retime <= settings.threshold2 then hotcolor = settings.color2 end
			if retime <= settings.threshold3 then hotcolor = settings.color3 end
			self.core:SendStatusGained(name, "alert_renew",
				settings.priority,
				(settings.range and 40),
				hotcolor,
				tostring(math.floor(retime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_renew") then self.core:SendStatusLost(name, "alert_renew") end
		end
		if rgtime then
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_regrow
			local hotcolor = settings.color
			if retime <= settings.threshold2 then hotcolor = settings.color2 end
			if retime <= settings.threshold3 then hotcolor = settings.color3 end
			self.core:SendStatusGained(name, "alert_regrow",
				settings.priority,
				(settings.range and 40),
				hotcolor,
				tostring(math.floor(rgtime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_regrow") then self.core:SendStatusLost(name, "alert_regrow") end
		end
		if rjtime then
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_rejuv
			local hotcolor = settings.color
			if retime <= settings.threshold2 then hotcolor = settings.color2 end
			if retime <= settings.threshold3 then hotcolor = settings.color3 end
			self.core:SendStatusGained(name, "alert_rejuv",
				settings.priority,
				(settings.range and 40),
				hotcolor,
				tostring(math.floor(rjtime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_rejuv") then self.core:SendStatusLost(name, "alert_rejuv") end
		end
		if lbtime then
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_lifebl
			local hotcolor = settings.color
			if retime <= settings.threshold2 then hotcolor = settings.color2 end
			if retime <= settings.threshold3 then hotcolor = settings.color3 end
			self.core:SendStatusGained(name, "alert_lifebl",
				settings.priority,
				(settings.range and 40),
				hotcolor,
				tostring(math.floor(lbtime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_lifebl") then self.core:SendStatusLost(name, "alert_lifebl") end
		end

	end
end